Package org.springframework.cache.concurrent

# Class ConcurrentMapCache

java.lang.Object
org.springframework.cache.support.AbstractValueAdaptingCache
org.springframework.cache.concurrent.ConcurrentMapCache

All Implemented Interfaces:
  `Cache`

public class ConcurrentMapCache extends AbstractValueAdaptingCache
Simple `Cache` implementation based on the core JDK `java.util.concurrent` package.

Useful for testing or simple caching scenarios, typically in combination with `SimpleCacheManager` or dynamically through `ConcurrentMapCacheManager`.

Supports the `retrieve(Object)` and `retrieve(Object, Supplier)` operations in a best-effort fashion, relying on default `CompletableFuture` execution (typically within the JVM's `ForkJoinPool.commonPool()`).

Note: As `ConcurrentHashMap` (the default implementation used) does not allow for `null` values to be stored, this class will replace them with a predefined internal object. This behavior can be changed through the `ConcurrentMapCache(String, ConcurrentMap, boolean)` constructor.

Since:
  3.1
Author:
  Costin Leau, Juergen Hoeller, Stephane Nicoll
See Also:
  - `ConcurrentMapCacheManager`

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.springframework.cache.Cache

`Cache.ValueRetrievalException, Cache.ValueWrapper`

## Constructor Summary

Constructors
Modifier
Constructor
Description
``
`ConcurrentMapCache(String name)`
Create a new ConcurrentMapCache with the specified name.
``
`ConcurrentMapCache(String name, boolean allowNullValues)`
Create a new ConcurrentMapCache with the specified name.
``
`ConcurrentMapCache(String name, ConcurrentMap<Object,Object> store, boolean allowNullValues)`
Create a new ConcurrentMapCache with the specified name and the given internal `ConcurrentMap` to use.
`protected`
`ConcurrentMapCache(String name, ConcurrentMap<Object,Object> store, boolean allowNullValues, org.springframework.core.serializer.support.SerializationDelegate serialization)`
Create a new ConcurrentMapCache with the specified name and the given internal `ConcurrentMap` to use.

## Method Summary

Modifier and Type
Method
Description
`void`
`clear()`
Clear the cache through removing all mappings.
`void`
`evict(Object key)`
Evict the mapping for this key from this cache if it is present.
`boolean`
`evictIfPresent(Object key)`
Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.
`protected Object`
`fromStoreValue(Object storeValue)`
Convert the given value from the internal store to a user value returned from the get method (adapting `null`).
`<T> T`
`get(Object key, Callable<T> valueLoader)`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary.
`final String`
`getName()`
Return the cache name.
`final ConcurrentMap<Object,Object>`
`getNativeCache()`
Return the underlying native cache provider.
`boolean`
`invalidate()`
Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.
`final boolean`
`isStoreByValue()`
Return whether this cache stores a copy of each entry (`true`) or a reference (`false`, default).
`protected Object`
`lookup(Object key)`
Perform an actual lookup in the underlying store.
`void`
`put(Object key, Object value)`
Associate the specified value with the specified key in this cache.
`Cache.ValueWrapper`
`putIfAbsent(Object key, Object value)`
Atomically associate the specified value with the specified key in this cache if it is not set already.
`CompletableFuture<?>`
`retrieve(Object key)`
Return the value to which this cache maps the specified key, wrapped in a `CompletableFuture`.
`<T> CompletableFuture<T>`
`retrieve(Object key, Supplier<CompletableFuture<T>> valueLoader)`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary.
`protected Object`
`toStoreValue(Object userValue)`
Convert the given user value, as passed into the put method, to a value in the internal store (adapting `null`).

### Methods inherited from class org.springframework.cache.support.AbstractValueAdaptingCache

`get, get, isAllowNullValues, toValueWrapper`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ConcurrentMapCache

public ConcurrentMapCache(String name)
Create a new ConcurrentMapCache with the specified name.

Parameters:
  `name` - the name of the cache

### ConcurrentMapCache

public ConcurrentMapCache(String name, boolean allowNullValues)
Create a new ConcurrentMapCache with the specified name.

Parameters:
  `name` - the name of the cache
  `allowNullValues` - whether to accept and convert `null` values for this cache

### ConcurrentMapCache

public ConcurrentMapCache(String name, ConcurrentMap<Object,Object> store, boolean allowNullValues)
Create a new ConcurrentMapCache with the specified name and the given internal `ConcurrentMap` to use.

Parameters:
  `name` - the name of the cache
  `store` - the ConcurrentMap to use as an internal store
  `allowNullValues` - whether to allow `null` values (adapting them to an internal null holder value)

### ConcurrentMapCache

protected ConcurrentMapCache(String name, ConcurrentMap<Object,Object> store, boolean allowNullValues, @Nullable org.springframework.core.serializer.support.SerializationDelegate serialization)
Create a new ConcurrentMapCache with the specified name and the given internal `ConcurrentMap` to use. If the `SerializationDelegate` is specified, `store-by-value` is enabled

Parameters:
  `name` - the name of the cache
  `store` - the ConcurrentMap to use as an internal store
  `allowNullValues` - whether to allow `null` values (adapting them to an internal null holder value)
  `serialization` - the `SerializationDelegate` to use to serialize cache entry or `null` to store the reference
Since:
  4.3

## Method Details

### isStoreByValue

public final boolean isStoreByValue()
Return whether this cache stores a copy of each entry (`true`) or a reference (`false`, default). If store by value is enabled, each entry in the cache must be serializable.

Since:
  4.3

### getName

public final String getName()
Description copied from interface: `Cache`
Return the cache name.

### getNativeCache

public final ConcurrentMap<Object,Object> getNativeCache()
Description copied from interface: `Cache`
Return the underlying native cache provider.

### lookup

@Nullable protected Object lookup(Object key)
Description copied from class: `AbstractValueAdaptingCache`
Perform an actual lookup in the underlying store.

Specified by:
  `lookup` in class `AbstractValueAdaptingCache`
Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the raw store value for the key, or `null` if none

### get

@Nullable public <T> T get(Object key, Callable<T> valueLoader)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary. This method provides a simple substitute for the conventional "if cached, return; otherwise create, cache and return" pattern.

If possible, implementations should ensure that the loading operation is synchronized so that the specified `valueLoader` is only called once in case of concurrent access on the same key.

If the `valueLoader` throws an exception, it is wrapped in a `Cache.ValueRetrievalException`

Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the value to which this cache maps the specified key
See Also:
  - `Cache.get(Object)`

### retrieve

@Nullable public CompletableFuture<?> retrieve(Object key)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key, wrapped in a `CompletableFuture`. This operation must not block but is allowed to return a completed `CompletableFuture` if the corresponding value is immediately available.

Can return `null` if the cache can immediately determine that it contains no mapping for this key (for example, through an in-memory key map). Otherwise, the cached value will be returned in the `CompletableFuture`, with `null` indicating a late-determined cache miss. A nested `Cache.ValueWrapper` potentially indicates a nullable cached value; the cached value may also be represented as a plain element if null values are not supported. Calling code needs to be prepared to handle all those variants of the result returned by this method.

Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the value to which this cache maps the specified key, contained within a `CompletableFuture` which may also be empty when a cache miss has been late-determined. A straight `null` being returned means that the cache immediately determined that it contains no mapping for this key. A `Cache.ValueWrapper` contained within the `CompletableFuture` indicates a cached value that is potentially `null`; this is sensible in a late-determined scenario where a regular CompletableFuture-contained `null` indicates a cache miss. However, a cache may also return a plain value if it does not support the actual caching of `null` values, avoiding the extra level of value wrapping. Spring's cache processing can deal with all such implementation strategies.
See Also:
  - `Cache.retrieve(Object, Supplier)`

### retrieve

public <T> CompletableFuture<T> retrieve(Object key, Supplier<CompletableFuture<T>> valueLoader)
Description copied from interface: `Cache`
Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary. This method provides a simple substitute for the conventional "if cached, return; otherwise create, cache and return" pattern, based on `CompletableFuture`. This operation must not block.

If possible, implementations should ensure that the loading operation is synchronized so that the specified `valueLoader` is only called once in case of concurrent access on the same key.

Null values always indicate a user-level `null` value with this method. The provided `CompletableFuture` handle produces a value or raises an exception. If the `valueLoader` raises an exception, it will be propagated to the returned `CompletableFuture` handle.

Parameters:
  `key` - the key whose associated value is to be returned
Returns:
  the value to which this cache maps the specified key, contained within a `CompletableFuture` which will never be `null`. The provided future is expected to produce a value or raise an exception.
See Also:
  - `Cache.retrieve(Object)`
  - `Cache.get(Object, Callable)`

### put

public void put(Object key, @Nullable Object value)
Description copied from interface: `Cache`
Associate the specified value with the specified key in this cache.

If the cache previously contained a mapping for this key, the old value is replaced by the specified value.

Actual registration may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly not seeing the entry yet. This may for example be the case with transactional cache decorators. Use `Cache.putIfAbsent(java.lang.Object, java.lang.Object)` for guaranteed immediate registration.

If the cache is supposed to be compatible with `CompletableFuture` and reactive interactions, the put operation needs to be effectively non-blocking, with any backend write-through happening asynchronously. This goes along with a cache implemented and configured to support `Cache.retrieve(Object)` and `Cache.retrieve(Object, Supplier)`.

Parameters:
  `key` - the key with which the specified value is to be associated
  `value` - the value to be associated with the specified key
See Also:
  - `Cache.putIfAbsent(Object, Object)`

### putIfAbsent

@Nullable public Cache.ValueWrapper putIfAbsent(Object key, @Nullable Object value)
Description copied from interface: `Cache`
Atomically associate the specified value with the specified key in this cache if it is not set already.

This is equivalent to:

     ValueWrapper existingValue = cache.get(key);
     if (existingValue == null) {
         cache.put(key, value);
     }
     return existingValue;

except that the action is performed atomically. While all out-of-the-box `CacheManager` implementations are able to perform the put atomically, the operation may also be implemented in two steps, for example, with a check for presence and a subsequent put, in a non-atomic way. Check the documentation of the native cache implementation that you are using for more details.

The default implementation delegates to `Cache.get(Object)` and `Cache.put(Object, Object)` along the lines of the code snippet above.

Parameters:
  `key` - the key with which the specified value is to be associated
  `value` - the value to be associated with the specified key
Returns:
  the value to which this cache maps the specified key (which may be `null` itself), or also `null` if the cache did not contain any mapping for that key prior to this call. Returning `null` is therefore an indicator that the given `value` has been associated with the key.
See Also:
  - `Cache.put(Object, Object)`

### evict

public void evict(Object key)
Description copied from interface: `Cache`
Evict the mapping for this key from this cache if it is present.

Actual eviction may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entry. This may for example be the case with transactional cache decorators. Use `Cache.evictIfPresent(java.lang.Object)` for guaranteed immediate removal.

If the cache is supposed to be compatible with `CompletableFuture` and reactive interactions, the evict operation needs to be effectively non-blocking, with any backend write-through happening asynchronously. This goes along with a cache implemented and configured to support `Cache.retrieve(Object)` and `Cache.retrieve(Object, Supplier)`.

Parameters:
  `key` - the key whose mapping is to be removed from the cache
See Also:
  - `Cache.evictIfPresent(Object)`

### evictIfPresent

public boolean evictIfPresent(Object key)
Description copied from interface: `Cache`
Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.

The default implementation delegates to `Cache.evict(Object)`, returning `false` for not-determined prior presence of the key. Cache providers and in particular cache decorators are encouraged to perform immediate eviction if possible (for example, in case of generally deferred cache operations within a transaction) and to reliably determine prior presence of the given key.

Parameters:
  `key` - the key whose mapping is to be removed from the cache
Returns:
  `true` if the cache was known to have a mapping for this key before, `false` if it did not (or if prior presence could not be determined)
See Also:
  - `Cache.evict(Object)`

### clear

public void clear()
Description copied from interface: `Cache`
Clear the cache through removing all mappings.

Actual clearing may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entries. This may for example be the case with transactional cache decorators. Use `Cache.invalidate()` for guaranteed immediate removal of entries.

If the cache is supposed to be compatible with `CompletableFuture` and reactive interactions, the clear operation needs to be effectively non-blocking, with any backend write-through happening asynchronously. This goes along with a cache implemented and configured to support `Cache.retrieve(Object)` and `Cache.retrieve(Object, Supplier)`.

See Also:
  - `Cache.invalidate()`

### invalidate

public boolean invalidate()
Description copied from interface: `Cache`
Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.

Returns:
  `true` if the cache was known to have mappings before, `false` if it did not (or if prior presence of entries could not be determined)
See Also:
  - `Cache.clear()`

### toStoreValue

protected Object toStoreValue(@Nullable Object userValue)
Description copied from class: `AbstractValueAdaptingCache`
Convert the given user value, as passed into the put method, to a value in the internal store (adapting `null`).

Overrides:
  `toStoreValue` in class `AbstractValueAdaptingCache`
Parameters:
  `userValue` - the given user value
Returns:
  the value to store

### fromStoreValue

@Nullable protected Object fromStoreValue(@Nullable Object storeValue)
Description copied from class: `AbstractValueAdaptingCache`
Convert the given value from the internal store to a user value returned from the get method (adapting `null`).

Overrides:
  `fromStoreValue` in class `AbstractValueAdaptingCache`
Parameters:
  `storeValue` - the store value
Returns:
  the value to return to the user